Longfellow ZK 0290cb32

Loading...
Searching...
No Matches
Data Structures | Public Types | Public Member Functions | Static Public Attributes
proofs::FpGeneric< W64, optimized_mul, OPS > Class Template Reference

## Data Structures
struct | CElt
struct | Elt

## Public Types
using | N = Nat<W64>
using | limb_t = typename N::limb_t
using | TypeTag = PrimeFieldTypeTag

## Public Member Functions
| FpGeneric (const N &modulus)
| FpGeneric (const StaticString s)
template<size_t LEN>
| FpGeneric (const char(&s)[LEN])
| FpGeneric (const FpGeneric &)=delete
FpGeneric & | operator= (const FpGeneric &)=delete
template<size_t N>
Elt | of_string (const char(&s)[N]) const
Elt | of_string (const StaticString &s) const
std::optional< Elt > | of_untrusted_string (const char *s) const
void | add (Elt &a, const Elt &y) const
void | sub (Elt &a, const Elt &y) const
void | mul (Elt &x, const Elt &y) const
void | neg (Elt &x) const
void | invert (Elt &x) const
Elt | addf (Elt a, const Elt &y) const
Elt | subf (Elt a, const Elt &y) const
Elt | mulf (Elt a, const Elt &y) const
Elt | negf (Elt a) const
Elt | invertf (Elt x) const
N | from_montgomery_reference (const Elt &x) const
N | from_montgomery (const Elt &x) const
Elt | to_montgomery (const N &xn) const
bool | in_subfield (const Elt &e) const
Elt | of_scalar (uint64_t a) const
Elt | beta (size_t i) const
Elt | of_scalar_field (uint64_t a) const
Elt | of_scalar_field (const std::array< uint64_t, W64 > &a) const
Elt | of_scalar_field (const N &a) const
std::optional< Elt > | of_bytes_field (const uint8_t ab[]) const
void | to_bytes_field (uint8_t ab[], const Elt &x) const
std::optional< Elt > | of_bytes_subfield (const uint8_t ab[]) const
void | to_bytes_subfield (uint8_t ab[], const Elt &x) const
const Elt & | zero () const
const Elt & | one () const
const Elt & | two () const
const Elt & | half () const
const Elt & | mone () const
Elt | poly_evaluation_point (size_t i) const
Elt | newton_denominator (size_t k, size_t i) const
CElt | as_counter (uint64_t a) const
Elt | znz_indicator (const CElt &celt) const

## Static Public Attributes
static constexpr size_t | kU64 = N::kU64
static constexpr size_t | kBytes = N::kBytes
static constexpr size_t | kSubFieldBytes = kBytes
static constexpr size_t | kBits = N::kBits
static constexpr size_t | kLimbs = N::kLimbs
static constexpr bool | kCharacteristicTwo = false
static constexpr size_t | kNPolyEvaluationPoints = 6

The documentation for this class was generated from the following file:

- lib/algebra/fp_generic.h